if srb2p then return end

local sS = speccyStuff

-- Kirby Support... I don't really like Kirbo.

if not(kirbyabilitytable)
    rawset(_G, "kirbyabilitytable", {})
end

kirbyabilitytable["legacyspeccy"] = 10

-- Metroid Vanguard Support

addHook("PlayerThink", function(p) 
		
	if skins["samus"] == nil then return end
	
	-- Boss tables.
	
	-- Two Omega Metroid based things to prevent it from showing BOSS.
	
	sS.BossTable[MT_METROIDPART] = {"Omega Metroid", 50, 550}
	sS.BossTable[MT_METROIDBOSS] = {"Omega Metroid", 50, 0}
	
	-- Dark Samus.
	
	sS.BossTable[MT_PZBOSS] = {"Dark Samus", 75, 850}
	
	-- Inflictors
	
	-- Anything Omega Metroid related.
	
	sS.InfTable[MT_METROIDSLASH] = 50
	
	-- Dark Samus' stuff?
	
	sS.InfTable[MT_PZWAVEHOMER] = 60
	sS.InfTable[MT_PZBARRIER] = 75
	
	-- Samus / Dark Samus' projectiles.
	
	sS.InfTable[MT_PBSHOT] = 10 -- Power Beam Shot
	sS.InfTable[MT_PBCHARGESHOT] = 25 -- Charged Power Beam Shot
	sS.InfTable[MT_SAMMISSILE] = 30 -- Missile
	sS.InfTable[MT_SAMSUPERMISSILE] = 30 -- Super Missile
	sS.InfTable[MT_SAMMORPHBOMB] = 10 -- Morph Ball Bomb
	sS.InfTable[MT_SAMPOWERBOMB] = 25 -- Morph Ball Power Bomb
	sS.InfTable[MT_SPSHOT] = 15 -- Spazer Beam Shot
	sS.InfTable[MT_SPCHARGESHOT] = 30 -- Charged Spazer Beam Shot
	sS.InfTable[MT_WVSHOT] = 12 -- Wave Beam Shot
	sS.InfTable[MT_WVCHARGESHOT] = 27 -- Charged Wave Beam Shot
	sS.InfTable[MT_ICSHOT] = 5 -- Ice Beam Shot
	sS.InfTable[MT_ICCHARGESHOT] = 20 -- Charged Ice Beam Shot
	sS.InfTable[MT_PLSHOT] = 25 -- Plazma Beam Shot
	sS.InfTable[MT_PLCHARGESHOT] = 50 -- Charged Plazma Beam Shot
	sS.InfTable[MT_HBSHOT] = 150 -- Hyper Beam Shot... scary!	
	
	-- Now for the scariest of all, BEAM COMBOS!!!.. nevermind.
	
	sS.InfTable[MT_SPCHARGECOMBO] = 75
	sS.InfTable[MT_ICCHARGECOMBO] = 65
	
end)

-- Super Brak.

rawset(_G, "speccyBrakVersion", function(p, brak)
	if brak.superbraktransform then
		if brak.superbraktranstics == nil then
			brak.superbraktranstics = 0
			brak.shield = 0
			S_StartSound(p.mo, sfx_behurt)
			S_StartSound(p.mo, sfx_bedie2)
			P_FlashPal(p, PAL_NUKE, TICRATE/4)
			brak.health = 2
			P_TeleportMove(p.mo, p.mo.x, p.mo.y + 1024*FRACUNIT, brak.z)
		elseif brak.superbraktranstics < TICRATE/2 then
			brak.scale = $ + FRACUNIT/17
			brak.superbraktranstics = $ + 1
			brak.shield = $ + 1
		else
			brak.health = 3
			brak.specbrak = 1
			S_ChangeMusic("SPBLAK", true)
		end
		return
	end
	if not p.speccy then return end
	if not (p.speccy.level >= 200) then return end
	
	if leveltime < 4 then
		brak.superbraktransform = 1
		if (gamemap == 27)
			for sector in sectors.iterate do
				if sector.floorheight == 608*FRACUNIT
					sector.floorheight = 512*FRACUNIT
				end
				for rover in sector.ffloors() do
					if rover.sector == sectors[36] then
						EV_CrumbleChain(sector, rover)
					elseif rover.sector == sectors[44] then
						rover.topheight = 480*FRACUNIT
						rover.bottomheight = 480*FRACUNIT
					end
				end
				if (sector == sectors[4])
						sector.ceilingheight = 480*FRACUNIT
					end
				if (sector == sectors[3] or sector == sectors[79] or sector == sectors[8]) //Most efficient method.
					if (sector == sectors[8])
						sector.ceilingheight = 480*FRACUNIT
					end
						sector.floorheight = 480*FRACUNIT
						sector.floorpic = "ERZRCKF1"
						sector.special = 0
					if sector == sectors[8]
						sector.lightlevel = 142
					else
						sector.lightlevel = 192
					end
				end
				if sector.special == 18
					sector.special = 16
				end
			end
		end
	end
end)

local function A_BrakFireShotLua(actor, var1)
	local x 
	local y 
	local z
	local locvar1 = var1

	if (not actor.target)
		return
	end

	A_FaceTarget(actor)

	x = actor.x
		P_ReturnThrustX(actor, actor.angle, FixedMul(64*FRACUNIT, actor.scale))
		P_ReturnThrustX(actor, actor.angle+ANGLE_270, FixedMul(32*FRACUNIT, actor.scale))
	y = actor.y
		P_ReturnThrustY(actor, actor.angle, FixedMul(64*FRACUNIT, actor.scale))
		P_ReturnThrustY(actor, actor.angle+ANGLE_270, FixedMul(32*FRACUNIT, actor.scale))
	if (actor.eflags & MFE_VERTICALFLIP)
		z = actor.z + actor.height - FixedMul(144*FRACUNIT, actor.scale)
	else
		z = actor.z + FixedMul(144*FRACUNIT, actor.scale)
	end
	local missile = P_SpawnXYZMissile(actor, actor.target, locvar1, x, y, z)

	if (not(actor.flags & MF_BOSS))
	
		if (ultimatemode)
			actor.reactiontime = actor.info.reactiontime*TICRATE
		else
			actor.reactiontime = actor.info.reactiontime*TICRATE*2
		end
	end
	return missile
end

local function brakCanAttack(brak)
	 if brak.state ~= S_CYBRAKDEMON_MISSILE_ATTACK1 and brak.state ~= S_CYBRAKDEMON_MISSILE_ATTACK2 and brak.state ~= S_CYBRAKDEMON_MISSILE_ATTACK3 and brak.state ~= S_CYBRAKDEMON_MISSILE_ATTACK4 and brak.state ~= S_CYBRAKDEMON_MISSILE_ATTACK5 and brak.state ~= S_CYBRAKDEMON_MISSILE_ATTACK6 and brak.state ~= S_CYBRAKDEMON_FLAME_ATTACK1 and brak.state ~= S_CYBRAKDEMON_FLAME_ATTACK2 and brak.state ~= S_CYBRAKDEMON_FLAME_ATTACK3 and brak.state ~= S_CYBRAKDEMON_FLAME_ATTACK4 and brak.state ~= S_CYBRAKDEMON_VILE_ATTACK1 and brak.state ~= S_CYBRAKDEMON_VILE_ATTACK2 and brak.state ~= S_CYBRAKDEMON_VILE_ATTACK3 and brak.state ~= S_CYBRAKDEMON_VILE_ATTACK4 and brak.state ~= S_CYBRAKDEMON_VILE_ATTACK5 and brak.state ~= S_CYBRAKDEMON_VILE_ATTACK6 and brak.state ~= S_CYBRAKDEMON_NAPALM_ATTACK1 and brak.state ~= S_CYBRAKDEMON_NAPALM_ATTACK2 and brak.state ~= S_CYBRAKDEMON_NAPALM_ATTACK3 then
		if not P_IsObjectOnGround(brak) then return false end
		if not brak.target then return false end
		if (brak.flags2 & MF2_FRET) then return false end
		if brak.cooldown then return false end
		return true
	 end
	 return false
end

addHook("MobjThinker", function(brak)
	if brak.state == S_CYBRAKDEMON_DIE8 then return true end
	if brak.superbrak or brak.specbrak then
		if brak.superbrak then
			sS.BossTable[MT_CYBRAKDEMON] = {"Super B. Eggman", 215, 3500}
		else
			sS.BossTable[MT_CYBRAKDEMON] = {"True B. Eggman", 175, 2500}
		end
		if brak.specbrak then
			if brak.shieldregen then
				brak.shieldregen = $ - 1
				brak.shield = $ + 1
			end
			if P_IsObjectOnGround(brak) and brak.state == S_BLACKEGG_JUMP2 then
				brak.state = mobjinfo[brak.type].spawnstate
				P_StartQuake(64*FRACUNIT, TICRATE/2)
				S_StartSound(brak, sfx_befall)
				for i=0,7 do
					local skid = P_SpawnMobj(brak.x, brak.y, brak.z, MT_SPINDUST)
					skid.scale = 6*FRACUNIT
					if skid and skid.valid then
						skid.angle = FixedAngle(i*(45*FRACUNIT))
						P_InstaThrust(skid, skid.angle, 64*FRACUNIT)
					end
				end
				if brak.specpinch then
					brak.cooldown = 5*TICRATE
				else
					brak.cooldown = 10*TICRATE
				end
				brak.state = S_CYBRAKDEMON_WALK1
			end
			if brak.cooldown then
				brak.cooldown = $ - 1
				return false
			end
			if not brak.specpinch then
				if leveltime % 105*P_RandomRange(10,50) == 0 and brakCanAttack(brak) then
					if P_RandomRange(1,6) == 2 and R_PointToDist2(brak.x, brak.y, brak.target.x, brak.target.y) <= 4096*FRACUNIT then
						brak.gooptime = TICRATE/2
					elseif P_RandomRange(1,4) == 2 then
						brak.cannontime = 3*TICRATE
					else
						A_FaceTarget(brak)
						P_Thrust(brak, brak.angle, R_PointToDist2(brak.x, brak.y, brak.target.x, brak.target.y)/TICRATE/2)
						P_SetObjectMomZ(brak, brak.height/35, false)
						brak.state = S_BLACKEGG_JUMP1
					end
				end
			else
				if leveltime % 70*P_RandomRange(10,50) == 0 and brakCanAttack(brak) then
					if P_RandomRange(1,6) == 2 and R_PointToDist2(brak.x, brak.y, brak.target.x, brak.target.y) <= 4096*FRACUNIT then
						brak.gooptime = TICRATE/2
					elseif P_RandomRange(1,4) == 2 then
						brak.cannontime = 3*TICRATE
					else
						A_FaceTarget(brak)
						P_Thrust(brak, brak.angle, R_PointToDist2(brak.x, brak.y, brak.target.x, brak.target.y)/TICRATE/2)
						P_SetObjectMomZ(brak, brak.height/35, false)
						brak.state = S_BLACKEGG_JUMP1
					end
				end
			end
			brak.mass = 200*FRACUNIT
			if brak.gooptime then
				if not brak.specpinch then
					for i=1,4 do
						local brakgoop = A_BrakFireShotLua(brak, MT_BLACKEGGMAN_GOOPFIRE)
						if brakgoop and brakgoop.valid then
							if i==1 then
								P_SetObjectMomZ(brakgoop, 2*FRACUNIT, true)
							elseif i==2 then
								P_Thrust(brakgoop, brakgoop.angle+ANGLE_45, 4*FRACUNIT)
							elseif i==3 then
								P_Thrust(brakgoop, brakgoop.angle-ANGLE_45, 4*FRACUNIT)
							else
								P_SetObjectMomZ(brakgoop, -2*FRACUNIT, true)
							end
						end
					end
				else
					for i=1,8 do
						local brakgoop = A_BrakFireShotLua(brak, MT_BLACKEGGMAN_GOOPFIRE)
						if brakgoop and brakgoop.valid then
							if i==1 then
								P_SetObjectMomZ(brakgoop, 2*FRACUNIT, true)
							elseif i==2 then
								P_Thrust(brakgoop, brakgoop.angle+ANGLE_45, 4*FRACUNIT)
								P_SetObjectMomZ(brakgoop, 2*FRACUNIT, true)
							elseif i==3 then
								P_Thrust(brakgoop, brakgoop.angle+ANGLE_90, 4*FRACUNIT)
							elseif i==4 then
								P_Thrust(brakgoop, brakgoop.angle+ANGLE_45, 4*FRACUNIT)
								P_SetObjectMomZ(brakgoop, -2*FRACUNIT, true)
							elseif i==5 then
								P_SetObjectMomZ(brakgoop, -2*FRACUNIT, true)
							elseif i==6 then
								P_Thrust(brakgoop, brakgoop.angle-ANGLE_45, 4*FRACUNIT)
								P_SetObjectMomZ(brakgoop, -2*FRACUNIT, true)
							elseif i==7
								P_Thrust(brakgoop, brakgoop.angle-ANGLE_90, 4*FRACUNIT)
							else
								P_Thrust(brakgoop, brakgoop.angle-ANGLE_45, 4*FRACUNIT)
								P_SetObjectMomZ(brakgoop, 2*FRACUNIT, true)
							end
						end
					end
				end
				
				brak.state = mobjinfo[brak.type].missilestate
				brak.gooptime = $ - 1
				brak.momx = 0
				brak.momy = 0
				if brak.gooptime == 0 then
					if brak.specpinch then
						brak.cooldown = 2*TICRATE
					else
						brak.cooldown = 5*TICRATE
					end
					brak.state = S_CYBRAKDEMON_WALK1
					brak.flags2 = $ & ~MF2_FRET
				end
				return true
			elseif brak.cannontime then
				if not brak.specpinch then
					if brak.cannontime % TICRATE == 0 then
						local cannonball = A_BrakFireShotLua(brak, MT_CANNONBALL)
						cannonball.momz = R_PointToDist2(brak.x, brak.y, brak.target.x, brak.target.y)/TICRATE/2 - 4*FRACUNIT
						--levelup 200;map map25
					end
				else
					if brak.cannontime % TICRATE/2 == 0 then
						local energyball = A_BrakFireShotLua(brak, MT_ENERGYBALL)
						--levelup 200;map map25
					end
				end
				brak.state = S_BLACKEGG_GOOP
				brak.cannontime = $ - 1
				brak.momx = 0
				brak.momy = 0
				if brak.cannontime == 0 then
					brak.state = S_CYBRAKDEMON_WALK1
					brak.flags2 = $ & ~MF2_FRET
					if brak.specpinch then
						brak.cooldown = 2*TICRATE
					else
						brak.cooldown = 5*TICRATE
					end
				end
				return true
			end
			for sector in sectors.iterate do
				if sector == sectors[66] or sector == sectors[43] or sector == sectors[72] or sector == sectors[83] then
					if sector.floorheight > 496*FRACUNIT
						sector.floorheight =  $ - 2*FRACUNIT
					end
				end
			end
		end
	else
		for p in players.iterate do
		
			if skins["samus"] == nil then speccyBrakVersion(p, brak) continue end
			if not p.speccy then continue end
			if not (p.speccy.level >= 200) then continue end
		
			if leveltime < 5 then
				brak.superbraktransform = 1
				if (gamemap == 27)
					for sector in sectors.iterate
						if sector.floorheight == 608*FRACUNIT
						sector.floorheight = 512*FRACUNIT
						end
						if (sector == sectors[3] or sector == sectors[79] or sector == sectors[8]) //Most efficient method.
							if (sector == sectors[8])
							sector.ceilingheight = 480*FRACUNIT
							end
							sector.floorheight = 480*FRACUNIT
							sector.floorpic = "ERZRCKF1"
							sector.special = 0
							if sector == sectors[8]
							sector.lightlevel = 142
							else
							sector.lightlevel = 192
							end
						end
						if sector.special == 18
						sector.special = 16
						end
					end
				end
			end
		end
		sS.BossTable[MT_CYBRAKDEMON] = {"Black Eggman", 100, 1000}
	end
end, MT_CYBRAKDEMON)

addHook("MobjDamage", function(brak)
	if brak.specbrak then
		if brak.shield > 0 then
			brak.shield = $ - 2
			brak.health = $ + 1
			return false
		elseif brak.health > 0
			if brak.health > 2 then
				brak.shieldregen = 17
			else
				brak.specpinch = true
				S_ChangeMusic("SPBKPN", true)
				brak.shieldregen = 34
			end
			return false
		end
	end
end, MT_CYBRAKDEMON)